diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/ipv6/radvd-two-prefix.cc ns-3.38/examples/ipv6/radvd-two-prefix.cc
--- ns-3.37/examples/ipv6/radvd-two-prefix.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/ipv6/radvd-two-prefix.cc	2023-03-16 20:54:23.568868400 -0700
@@ -27,7 +27,7 @@
 // // - R sends RA to n0's subnet (2001:1::/64 and 2001:ABCD::/64);
 // // - R interface to n0 has two addresses with following prefixes 2001:1::/64 and 2001:ABCD::/64;
 // // - R sends RA to n1's subnet (2001:2::/64);
-// // - n0 ping6 n1.
+// // - n0 ping n1.
 // //
 // // - Tracing of queues and packet receptions to file "radvd-two-prefix.tr"
 
@@ -98,7 +98,7 @@
         LogComponentEnable("Ipv6StaticRouting", LOG_LEVEL_ALL);
         LogComponentEnable("Ipv6Interface", LOG_LEVEL_ALL);
         LogComponentEnable("RadvdApplication", LOG_LEVEL_ALL);
-        LogComponentEnable("Ping6Application", LOG_LEVEL_ALL);
+        LogComponentEnable("Ping", LOG_LEVEL_ALL);
     }
 
     NS_LOG_INFO("Create nodes.");
@@ -190,28 +190,22 @@
     radvdApps.Start(Seconds(1.0));
     radvdApps.Stop(Seconds(2.0));
 
-    /* Create a Ping6 application to send ICMPv6 echo request from n0 to n1 via R */
+    /* Create a Ping application to send ICMPv6 echo request from n0 to n1 via R */
     uint32_t packetSize = 1024;
     uint32_t maxPacketCount = 8;
-    Time interPacketInterval = Seconds(1.);
-    Ping6Helper ping6;
-
-    /* ping6.SetLocal (iic1.GetAddress (0, 1)); */
-    ping6.SetRemote(
+    PingHelper ping(
         Ipv6Address("2001:2::200:ff:fe00:4")); /* should be n1 address after autoconfiguration */
-    ping6.SetIfIndex(iic1.GetInterfaceIndex(0));
+    // ping.SetIfIndex(iic1.GetInterfaceIndex(0));
 
-    ping6.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
-    ping6.SetAttribute("Interval", TimeValue(interPacketInterval));
-    ping6.SetAttribute("PacketSize", UintegerValue(packetSize));
-    ApplicationContainer apps = ping6.Install(net1.Get(0));
+    ping.SetAttribute("Count", UintegerValue(maxPacketCount));
+    ping.SetAttribute("Size", UintegerValue(packetSize));
+    ApplicationContainer apps = ping.Install(net1.Get(0));
     apps.Start(Seconds(2.0));
-    apps.Stop(Seconds(9.0));
+    apps.Stop(Seconds(5.0));
 
-    Ipv6StaticRoutingHelper routingHelper;
     Ptr<OutputStreamWrapper> routingStream = Create<OutputStreamWrapper>(&std::cout);
-    routingHelper.PrintRoutingTableAt(Seconds(2.0), n0, routingStream);
-    routingHelper.PrintRoutingTableAt(Seconds(10.0), n0, routingStream);
+    Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(2.0), n0, routingStream);
+    Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(10.0), n0, routingStream);
 
     IpAddressHelper ipAddressHelper;
     /* RA should be received, two prefixes + routes + default route should be present */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/ipv6/wsn-ping6.cc ns-3.38/examples/ipv6/wsn-ping6.cc
--- ns-3.37/examples/ipv6/wsn-ping6.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/ipv6/wsn-ping6.cc	2023-03-16 20:54:23.568868400 -0700
@@ -61,7 +61,7 @@
         LogComponentEnable("Ipv6ListRouting", LOG_LEVEL_ALL);
         LogComponentEnable("Ipv6Interface", LOG_LEVEL_ALL);
         LogComponentEnable("Icmpv6L4Protocol", LOG_LEVEL_ALL);
-        LogComponentEnable("Ping6Application", LOG_LEVEL_ALL);
+        LogComponentEnable("Ping", LOG_LEVEL_ALL);
         LogComponentEnable("NdiscCache", LOG_LEVEL_ALL);
         LogComponentEnable("SixLowPanNetDevice", LOG_LEVEL_ALL);
     }
@@ -88,7 +88,7 @@
     // Add and install the LrWpanNetDevice for each node
     // lrWpanHelper.EnableLogComponents();
     NetDeviceContainer devContainer = lrWpanHelper.Install(nodes);
-    lrWpanHelper.AssociateToPan(devContainer, 10);
+    lrWpanHelper.CreateAssociatedPan(devContainer, 10);
 
     std::cout << "Created " << devContainer.GetN() << " devices" << std::endl;
     std::cout << "There are " << nodes.GetN() << " nodes" << std::endl;
@@ -111,22 +111,18 @@
 
     NS_LOG_INFO("Create Applications.");
 
-    /* Create a Ping6 application to send ICMPv6 echo request from node zero to
+    /* Create a Ping application to send ICMPv6 echo request from node zero to
      * all-nodes (ff02::1).
      */
-    uint32_t packetSize = 10;
+    uint32_t packetSize = 16;
     uint32_t maxPacketCount = 5;
     Time interPacketInterval = Seconds(1.);
-    Ping6Helper ping6;
+    PingHelper ping(i.GetAddress(1, 1));
 
-    ping6.SetLocal(i.GetAddress(0, 1));
-    ping6.SetRemote(i.GetAddress(1, 1));
-    // ping6.SetRemote (Ipv6Address::GetAllNodesMulticast ());
-
-    ping6.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
-    ping6.SetAttribute("Interval", TimeValue(interPacketInterval));
-    ping6.SetAttribute("PacketSize", UintegerValue(packetSize));
-    ApplicationContainer apps = ping6.Install(nodes.Get(0));
+    ping.SetAttribute("Count", UintegerValue(maxPacketCount));
+    ping.SetAttribute("Interval", TimeValue(interPacketInterval));
+    ping.SetAttribute("Size", UintegerValue(packetSize));
+    ApplicationContainer apps = ping.Install(nodes.Get(0));
     apps.Start(Seconds(2.0));
     apps.Stop(Seconds(10.0));
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/matrix-topology/matrix-topology.cc ns-3.38/examples/matrix-topology/matrix-topology.cc
--- ns-3.37/examples/matrix-topology/matrix-topology.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/matrix-topology/matrix-topology.cc	2023-03-16 20:54:23.568868400 -0700
@@ -117,7 +117,7 @@
     std::vector<std::vector<double>> coord_array;
     coord_array = readCordinatesFile(node_coordinates_file_name);
 
-    // Optionally display node co-ordinates file
+    // Optionally display node coordinates file
     // printCoordinateArray (node_coordinates_file_name.c_str (),coord_array);
 
     int n_nodes = coord_array.size();
@@ -312,7 +312,7 @@
     {
         std::string line;
         getline(adj_mat_file, line);
-        if (line == "")
+        if (line.empty())
         {
             NS_LOG_WARN("WARNING: Ignoring blank row in the array: " << i);
             break;
@@ -377,7 +377,7 @@
         std::string line;
         getline(node_coordinates_file, line);
 
-        if (line == "")
+        if (line.empty())
         {
             NS_LOG_WARN("WARNING: Ignoring blank row: " << m);
             break;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/realtime/realtime-udp-echo.py ns-3.38/examples/realtime/realtime-udp-echo.py
--- ns-3.37/examples/realtime/realtime-udp-echo.py	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/realtime/realtime-udp-echo.py	2023-03-16 20:54:23.568868400 -0700
@@ -85,7 +85,7 @@
   packetSize = 1024
   maxPacketCount = 500
   interPacketInterval = ns.core.Seconds(0.01)
-  client = ns.applications.UdpEchoClientHelper(ns.addressFromIpv4Address(i.GetAddress (1)), port)
+  client = ns.applications.UdpEchoClientHelper(i.GetAddress(1).ConvertTo(), port)
   client.SetAttribute("MaxPackets", ns.core.UintegerValue(maxPacketCount))
   client.SetAttribute("Interval", ns.core.TimeValue(interPacketInterval))
   client.SetAttribute("PacketSize", ns.core.UintegerValue(packetSize))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/routing/dynamic-global-routing.cc ns-3.38/examples/routing/dynamic-global-routing.cc
--- ns-3.37/examples/routing/dynamic-global-routing.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/routing/dynamic-global-routing.cc	2023-03-16 20:54:23.568868400 -0700
@@ -210,10 +210,9 @@
     Simulator::Schedule(Seconds(14), &Ipv4::SetUp, ipv41, ipv4ifIndex1);
 
     // Trace routing tables
-    Ipv4GlobalRoutingHelper g;
     Ptr<OutputStreamWrapper> routingStream =
         Create<OutputStreamWrapper>("dynamic-global-routing.routes", std::ios::out);
-    g.PrintRoutingTableAllAt(Seconds(12), routingStream);
+    Ipv4RoutingHelper::PrintRoutingTableAllAt(Seconds(12), routingStream);
 
     NS_LOG_INFO("Run Simulation.");
     Simulator::Run();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/routing/global-routing-multi-switch-plus-router.cc ns-3.38/examples/routing/global-routing-multi-switch-plus-router.cc
--- ns-3.37/examples/routing/global-routing-multi-switch-plus-router.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/routing/global-routing-multi-switch-plus-router.cc	2023-03-16 20:54:23.568868400 -0700
@@ -332,7 +332,7 @@
     // Parse the pcapLocations string into pcapLocationVec
     // ----------------------------------------------------------------------
     std::vector<std::string> pcapLocationVec;
-    if (pcapLocations != "")
+    if (!pcapLocations.empty())
     {
         std::stringstream sStream(pcapLocations);
 
@@ -710,8 +710,7 @@
         Create<OutputStreamWrapper>("global-routing-multi-switch-plus-router.routes",
                                     std::ios::out);
 
-    Ipv4GlobalRoutingHelper g;
-    g.PrintRoutingTableAllAt(Seconds(0.1), routingStream);
+    Ipv4RoutingHelper::PrintRoutingTableAllAt(Seconds(0.1), routingStream);
 
     // ======================================================================
     // Configure PCAP traces
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/routing/manet-routing-compare.cc ns-3.38/examples/routing/manet-routing-compare.cc
--- ns-3.37/examples/routing/manet-routing-compare.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/routing/manet-routing-compare.cc	2023-03-16 20:54:23.568868400 -0700
@@ -102,7 +102,7 @@
     // static void SetMACParam (ns3::NetDeviceContainer & devices,
     //                                  int slotDistance);
     /**
-     * Handles the command-line parmeters.
+     * Handles the command-line parameters.
      * \param argc The argument count.
      * \param argv The argument vector.
      * \return the CSV filename.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/routing/ripng-simple-network.cc ns-3.38/examples/routing/ripng-simple-network.cc
--- ns-3.37/examples/routing/ripng-simple-network.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/routing/ripng-simple-network.cc	2023-03-16 20:54:23.568868400 -0700
@@ -96,12 +96,7 @@
         LogComponentEnable("Ipv6Interface", LOG_LEVEL_ALL);
         LogComponentEnable("Icmpv6L4Protocol", LOG_LEVEL_ALL);
         LogComponentEnable("NdiscCache", LOG_LEVEL_ALL);
-        LogComponentEnable("Ping6Application", LOG_LEVEL_ALL);
-    }
-
-    if (showPings)
-    {
-        LogComponentEnable("Ping6Application", LOG_LEVEL_INFO);
+        LogComponentEnable("Ping", LOG_LEVEL_ALL);
     }
 
     if (SplitHorizon == "NoSplitHorizon")
@@ -223,38 +218,36 @@
 
     if (printRoutingTables)
     {
-        RipNgHelper routingHelper;
-
         Ptr<OutputStreamWrapper> routingStream = Create<OutputStreamWrapper>(&std::cout);
 
-        routingHelper.PrintRoutingTableAt(Seconds(30.0), a, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(30.0), b, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(30.0), c, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(30.0), d, routingStream);
-
-        routingHelper.PrintRoutingTableAt(Seconds(60.0), a, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(60.0), b, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(60.0), c, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(60.0), d, routingStream);
-
-        routingHelper.PrintRoutingTableAt(Seconds(90.0), a, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(90.0), b, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(90.0), c, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(90.0), d, routingStream);
+        Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(30.0), a, routingStream);
+        Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(30.0), b, routingStream);
+        Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(30.0), c, routingStream);
+        Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(30.0), d, routingStream);
+
+        Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(60.0), a, routingStream);
+        Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(60.0), b, routingStream);
+        Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(60.0), c, routingStream);
+        Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(60.0), d, routingStream);
+
+        Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(90.0), a, routingStream);
+        Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(90.0), b, routingStream);
+        Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(90.0), c, routingStream);
+        Ipv6RoutingHelper::PrintRoutingTableAt(Seconds(90.0), d, routingStream);
     }
 
     NS_LOG_INFO("Create Applications.");
     uint32_t packetSize = 1024;
-    uint32_t maxPacketCount = 100;
     Time interPacketInterval = Seconds(1.0);
-    Ping6Helper ping6;
+    PingHelper ping(iic7.GetAddress(1, 1));
 
-    ping6.SetLocal(iic1.GetAddress(0, 1));
-    ping6.SetRemote(iic7.GetAddress(1, 1));
-    ping6.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
-    ping6.SetAttribute("Interval", TimeValue(interPacketInterval));
-    ping6.SetAttribute("PacketSize", UintegerValue(packetSize));
-    ApplicationContainer apps = ping6.Install(src);
+    ping.SetAttribute("Interval", TimeValue(interPacketInterval));
+    ping.SetAttribute("Size", UintegerValue(packetSize));
+    if (showPings)
+    {
+        ping.SetAttribute("VerboseMode", EnumValue(Ping::VerboseMode::VERBOSE));
+    }
+    ApplicationContainer apps = ping.Install(src);
     apps.Start(Seconds(1.0));
     apps.Stop(Seconds(110.0));
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/routing/rip-simple-network.cc ns-3.38/examples/routing/rip-simple-network.cc
--- ns-3.37/examples/routing/rip-simple-network.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/routing/rip-simple-network.cc	2023-03-16 20:54:23.568868400 -0700
@@ -97,7 +97,7 @@
         LogComponentEnable("Icmpv4L4Protocol", LOG_LEVEL_ALL);
         LogComponentEnable("Ipv4L3Protocol", LOG_LEVEL_ALL);
         LogComponentEnable("ArpCache", LOG_LEVEL_ALL);
-        LogComponentEnable("V4Ping", LOG_LEVEL_ALL);
+        LogComponentEnable("Ping", LOG_LEVEL_ALL);
     }
 
     if (SplitHorizon == "NoSplitHorizon")
@@ -213,36 +213,34 @@
 
     if (printRoutingTables)
     {
-        RipHelper routingHelper;
-
         Ptr<OutputStreamWrapper> routingStream = Create<OutputStreamWrapper>(&std::cout);
 
-        routingHelper.PrintRoutingTableAt(Seconds(30.0), a, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(30.0), b, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(30.0), c, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(30.0), d, routingStream);
-
-        routingHelper.PrintRoutingTableAt(Seconds(60.0), a, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(60.0), b, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(60.0), c, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(60.0), d, routingStream);
-
-        routingHelper.PrintRoutingTableAt(Seconds(90.0), a, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(90.0), b, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(90.0), c, routingStream);
-        routingHelper.PrintRoutingTableAt(Seconds(90.0), d, routingStream);
+        Ipv4RoutingHelper::PrintRoutingTableAt(Seconds(30.0), a, routingStream);
+        Ipv4RoutingHelper::PrintRoutingTableAt(Seconds(30.0), b, routingStream);
+        Ipv4RoutingHelper::PrintRoutingTableAt(Seconds(30.0), c, routingStream);
+        Ipv4RoutingHelper::PrintRoutingTableAt(Seconds(30.0), d, routingStream);
+
+        Ipv4RoutingHelper::PrintRoutingTableAt(Seconds(60.0), a, routingStream);
+        Ipv4RoutingHelper::PrintRoutingTableAt(Seconds(60.0), b, routingStream);
+        Ipv4RoutingHelper::PrintRoutingTableAt(Seconds(60.0), c, routingStream);
+        Ipv4RoutingHelper::PrintRoutingTableAt(Seconds(60.0), d, routingStream);
+
+        Ipv4RoutingHelper::PrintRoutingTableAt(Seconds(90.0), a, routingStream);
+        Ipv4RoutingHelper::PrintRoutingTableAt(Seconds(90.0), b, routingStream);
+        Ipv4RoutingHelper::PrintRoutingTableAt(Seconds(90.0), c, routingStream);
+        Ipv4RoutingHelper::PrintRoutingTableAt(Seconds(90.0), d, routingStream);
     }
 
     NS_LOG_INFO("Create Applications.");
     uint32_t packetSize = 1024;
     Time interPacketInterval = Seconds(1.0);
-    V4PingHelper ping("10.0.6.2");
+    PingHelper ping(Ipv4Address("10.0.6.2"));
 
     ping.SetAttribute("Interval", TimeValue(interPacketInterval));
     ping.SetAttribute("Size", UintegerValue(packetSize));
     if (showPings)
     {
-        ping.SetAttribute("Verbose", BooleanValue(true));
+        ping.SetAttribute("VerboseMode", EnumValue(Ping::VerboseMode::VERBOSE));
     }
     ApplicationContainer apps = ping.Install(src);
     apps.Start(Seconds(1.0));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/routing/simple-routing-ping6.cc ns-3.38/examples/routing/simple-routing-ping6.cc
--- ns-3.37/examples/routing/simple-routing-ping6.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/routing/simple-routing-ping6.cc	2023-03-16 20:54:23.568868400 -0700
@@ -98,7 +98,7 @@
   LogComponentEnable ("Icmpv6L4Protocol", LOG_LEVEL_ALL);
   LogComponentEnable ("Ipv6StaticRouting", LOG_LEVEL_ALL);
   LogComponentEnable ("Ipv6Interface", LOG_LEVEL_ALL);
-  LogComponentEnable ("Ping6Application", LOG_LEVEL_ALL);
+  LogComponentEnable ("Ping", LOG_LEVEL_ALL);
 #endif
 
     CommandLine cmd(__FILE__);
@@ -139,19 +139,14 @@
 
     stackHelper.PrintRoutingTable(n0);
 
-    /* Create a Ping6 application to send ICMPv6 echo request from n0 to n1 via r */
+    /* Create a Ping application to send ICMPv6 echo request from n0 to n1 via r */
     uint32_t packetSize = 1024;
     uint32_t maxPacketCount = 5;
-    Time interPacketInterval = Seconds(1.);
-    Ping6Helper ping6;
+    PingHelper ping(i2.GetAddress(1, 1));
 
-    ping6.SetLocal(i1.GetAddress(0, 1));
-    ping6.SetRemote(i2.GetAddress(1, 1));
-
-    ping6.SetAttribute("MaxPackets", UintegerValue(maxPacketCount));
-    ping6.SetAttribute("Interval", TimeValue(interPacketInterval));
-    ping6.SetAttribute("PacketSize", UintegerValue(packetSize));
-    ApplicationContainer apps = ping6.Install(net1.Get(0));
+    ping.SetAttribute("Count", UintegerValue(maxPacketCount));
+    ping.SetAttribute("Size", UintegerValue(packetSize));
+    ApplicationContainer apps = ping.Install(net1.Get(0));
     apps.Start(Seconds(2.0));
     apps.Stop(Seconds(20.0));
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/routing/simple-routing-ping6.py ns-3.38/examples/routing/simple-routing-ping6.py
--- ns-3.37/examples/routing/simple-routing-ping6.py	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/routing/simple-routing-ping6.py	2023-03-16 20:54:23.568868400 -0700
@@ -74,16 +74,17 @@
     packetSize = 1024
     maxPacketCount = 5
     interPacketInterval = ns.Seconds(1.)
-    ping6 = ns.Ping6Helper()
+    # ping = ns.PingHelper(i2.GetAddress(1, 1).ConvertTo())
+    ping = ns.PingHelper(i2.GetAddress(1, 1).ConvertTo())
 
-    ping6.SetLocal(i1.GetAddress(0, 1))
-    ping6.SetRemote(i2.GetAddress(1, 1))
+    # ping6.SetLocal(i1.GetAddress(0, 1))
+    # ping6.SetRemote(i2.GetAddress(1, 1))
 
-    ping6.SetAttribute("MaxPackets", ns.UintegerValue(maxPacketCount))
-    ping6.SetAttribute("Interval", ns.TimeValue(interPacketInterval))
-    ping6.SetAttribute("PacketSize", ns.UintegerValue(packetSize))
+    ping.SetAttribute("Count", ns.UintegerValue(maxPacketCount))
+    ping.SetAttribute("Interval", ns.TimeValue(interPacketInterval))
+    ping.SetAttribute("Size", ns.UintegerValue(packetSize))
 
-    apps = ping6.Install(ns.NodeContainer(net1.Get(0)))
+    apps = ping.Install(ns.NodeContainer(net1.Get(0)))
     apps.Start(ns.Seconds(2.0))
     apps.Stop(ns.Seconds(20.0))
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/stats/wifi-example-apps.cc ns-3.38/examples/stats/wifi-example-apps.cc
--- ns-3.37/examples/stats/wifi-example-apps.cc	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/stats/wifi-example-apps.cc	2023-03-16 20:54:23.568868400 -0700
@@ -37,6 +37,10 @@
 
 NS_LOG_COMPONENT_DEFINE("WiFiDistanceApps");
 
+// ==============================================
+// SENDER
+// ==============================================
+
 TypeId
 Sender::GetTypeId()
 {
@@ -46,7 +50,7 @@
                             .AddAttribute("PacketSize",
                                           "The size of packets transmitted.",
                                           UintegerValue(64),
-                                          MakeUintegerAccessor(&Sender::m_pktSize),
+                                          MakeUintegerAccessor(&Sender::m_packetSize),
                                           MakeUintegerChecker<uint32_t>(1))
                             .AddAttribute("Destination",
                                           "Target host address.",
@@ -61,7 +65,7 @@
                             .AddAttribute("NumPackets",
                                           "Total number of packets to send.",
                                           UintegerValue(30),
-                                          MakeUintegerAccessor(&Sender::m_numPkts),
+                                          MakeUintegerAccessor(&Sender::m_nPackets),
                                           MakeUintegerChecker<uint32_t>(1))
                             .AddAttribute("Interval",
                                           "Delay between transmissions.",
@@ -79,7 +83,6 @@
 {
     NS_LOG_FUNCTION_NOARGS();
     m_interval = CreateObject<ConstantRandomVariable>();
-    m_socket = nullptr;
 }
 
 Sender::~Sender()
@@ -114,8 +117,6 @@
 
     Simulator::Cancel(m_sendEvent);
     m_sendEvent = Simulator::ScheduleNow(&Sender::SendPacket, this);
-
-    // end Sender::StartApplication
 }
 
 void
@@ -123,16 +124,15 @@
 {
     NS_LOG_FUNCTION_NOARGS();
     Simulator::Cancel(m_sendEvent);
-    // end Sender::StopApplication
 }
 
 void
 Sender::SendPacket()
 {
-    // NS_LOG_FUNCTION_NOARGS ();
+    // NS_LOG_FUNCTION_NOARGS();
     NS_LOG_INFO("Sending packet at " << Simulator::Now() << " to " << m_destAddr);
 
-    Ptr<Packet> packet = Create<Packet>(m_pktSize);
+    Ptr<Packet> packet = Create<Packet>(m_packetSize);
 
     TimestampTag timestamp;
     timestamp.SetTimestamp(Simulator::Now());
@@ -145,18 +145,17 @@
     // Report the event to the trace.
     m_txTrace(packet);
 
-    if (++m_count < m_numPkts)
+    if (++m_count < m_nPackets)
     {
         m_sendEvent =
             Simulator::Schedule(Seconds(m_interval->GetValue()), &Sender::SendPacket, this);
     }
-
-    // end Sender::SendPacket
 }
 
-//----------------------------------------------------------------------
-//-- Receiver
-//------------------------------------------------------
+// ==============================================
+// RECEIVER
+// ==============================================
+
 TypeId
 Receiver::GetTypeId()
 {
@@ -172,11 +171,8 @@
 }
 
 Receiver::Receiver()
-    : m_calc(nullptr),
-      m_delay(nullptr)
 {
     NS_LOG_FUNCTION_NOARGS();
-    m_socket = nullptr;
 }
 
 Receiver::~Receiver()
@@ -209,8 +205,6 @@
     }
 
     m_socket->SetRecvCallback(MakeCallback(&Receiver::Receive, this));
-
-    // end Receiver::StartApplication
 }
 
 void
@@ -222,22 +216,18 @@
     {
         m_socket->SetRecvCallback(MakeNullCallback<void, Ptr<Socket>>());
     }
-
-    // end Receiver::StopApplication
 }
 
 void
 Receiver::SetCounter(Ptr<CounterCalculator<>> calc)
 {
     m_calc = calc;
-    // end Receiver::SetCounter
 }
 
 void
 Receiver::SetDelayTracker(Ptr<TimeMinMaxAvgTotalCalculator> delay)
 {
     m_delay = delay;
-    // end Receiver::SetDelayTracker
 }
 
 void
@@ -272,71 +262,5 @@
         {
             m_calc->Update();
         }
-
-        // end receiving packets
     }
-
-    // end Receiver::Receive
-}
-
-//----------------------------------------------------------------------
-//-- TimestampTag
-//------------------------------------------------------
-TypeId
-TimestampTag::GetTypeId()
-{
-    static TypeId tid = TypeId("TimestampTag")
-                            .SetParent<Tag>()
-                            .AddConstructor<TimestampTag>()
-                            .AddAttribute("Timestamp",
-                                          "Some momentous point in time!",
-                                          EmptyAttributeValue(),
-                                          MakeTimeAccessor(&TimestampTag::GetTimestamp),
-                                          MakeTimeChecker());
-    return tid;
-}
-
-TypeId
-TimestampTag::GetInstanceTypeId() const
-{
-    return GetTypeId();
-}
-
-uint32_t
-TimestampTag::GetSerializedSize() const
-{
-    return 8;
-}
-
-void
-TimestampTag::Serialize(TagBuffer i) const
-{
-    int64_t t = m_timestamp.GetNanoSeconds();
-    i.Write((const uint8_t*)&t, 8);
-}
-
-void
-TimestampTag::Deserialize(TagBuffer i)
-{
-    int64_t t;
-    i.Read((uint8_t*)&t, 8);
-    m_timestamp = NanoSeconds(t);
-}
-
-void
-TimestampTag::SetTimestamp(Time time)
-{
-    m_timestamp = time;
-}
-
-Time
-TimestampTag::GetTimestamp() const
-{
-    return m_timestamp;
-}
-
-void
-TimestampTag::Print(std::ostream& os) const
-{
-    os << "t=" << m_timestamp;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/examples/stats/wifi-example-apps.h ns-3.38/examples/stats/wifi-example-apps.h
--- ns-3.37/examples/stats/wifi-example-apps.h	2022-11-01 17:37:24.443395000 -0700
+++ ns-3.38/examples/stats/wifi-example-apps.h	2023-03-16 20:54:23.568868400 -0700
@@ -31,6 +31,10 @@
 
 using namespace ns3;
 
+// ==============================================
+// SENDER
+// ==============================================
+
 /**
  * Sender application.
  */
@@ -42,6 +46,7 @@
      * \return The object TypeId.
      */
     static TypeId GetTypeId();
+
     Sender();
     ~Sender() override;
 
@@ -57,23 +62,24 @@
      */
     void SendPacket();
 
-    uint32_t m_pktSize;                     //!< The packet size.
-    Ipv4Address m_destAddr;                 //!< Destination address.
-    uint32_t m_destPort;                    //!< Destination port.
-    Ptr<ConstantRandomVariable> m_interval; //!< Rng for sending packets.
-    uint32_t m_numPkts;                     //!< Number of packets to send.
+    Ipv4Address m_destAddr;                 //!< Destination address
+    uint32_t m_destPort{0};                 //!< Destination port
+    uint32_t m_packetSize{0};               //!< The packet size
+    Ptr<ConstantRandomVariable> m_interval; //!< Rng for sending packets
+    uint32_t m_nPackets{0};                 //!< Number of packets to send
+    uint32_t m_count{0};                    //!< Number of packets sent
 
-    Ptr<Socket> m_socket; //!< Sending socket.
-    EventId m_sendEvent;  //!< Send packet event.
+    Ptr<Socket> m_socket; //!< Sending socket
+    EventId m_sendEvent;  //!< Send packet event
 
-    /// Tx TracedCallback.
+    /// Tx TracedCallback
     TracedCallback<Ptr<const Packet>> m_txTrace;
-
-    uint32_t m_count; //!< Number of packets sent.
-
-    // end class Sender
 };
 
+// ==============================================
+// RECEIVER
+// ==============================================
+
 /**
  * Receiver application.
  */
@@ -85,6 +91,7 @@
      * \return The object TypeId.
      */
     static TypeId GetTypeId();
+
     Receiver();
     ~Receiver() override;
 
@@ -113,51 +120,9 @@
      */
     void Receive(Ptr<Socket> socket);
 
-    Ptr<Socket> m_socket; //!< Receiving socket.
-    uint32_t m_port;      //!< Listening port.
-
-    Ptr<CounterCalculator<>> m_calc;           //!< Counter of the number of received packets.
-    Ptr<TimeMinMaxAvgTotalCalculator> m_delay; //!< Delay calculator.
-
-    // end class Receiver
-};
-
-/**
- * Timestamp tag - it carries when the packet has been sent.
- *
- * It would have been more realistic to include this info in
- * a header. Here we show how to avoid the extra overhead in
- * a simulation.
- */
-class TimestampTag : public Tag
-{
-  public:
-    /**
-     * \brief Get the type ID.
-     * \return The object TypeId.
-     */
-    static TypeId GetTypeId();
-    TypeId GetInstanceTypeId() const override;
-
-    uint32_t GetSerializedSize() const override;
-    void Serialize(TagBuffer i) const override;
-    void Deserialize(TagBuffer i) override;
-
-    /**
-     * Set the timestamp.
-     * \param time The timestamp.
-     */
-    void SetTimestamp(Time time);
-    /**
-     * Get the timestamp.
-     * \return the timestamp.
-     */
-    Time GetTimestamp() const;
-
-    void Print(std::ostream& os) const override;
-
-  private:
-    Time m_timestamp; //!< Timestamp.
+    Ptr<Socket> m_socket; //!< Receiving socket
+    uint32_t m_port{0};   //!< Listening port
 
-    // end class TimestampTag
+    Ptr<CounterCalculator<>> m_calc;           //!< Counter of the number of received packets
+    Ptr<TimeMinMaxAvgTotalCalculator> m_delay; //!< Delay calculator
 };
